/*--------------------------------------------------------------------.
| qpop3.c							      |
| 								      |
| Copyright (c) 1999 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/
static char rcsid[] = "$Id: qpop3.c,v 1.4 1999/09/28 21:30:34 jrh Exp jrh $";
/*
 * $Log: qpop3.c,v $
 * Revision 1.4  1999/09/28 21:30:34  jrh
 * Changed for message display bug
 *
 * Revision 1.3  1999/09/20 20:53:57  jrh
 * Fixed menu bugs and multi-select
 *
 * Revision 1.2  1999/09/20 19:56:32  jrh
 * Added extra info window to sort out fscking stupid PE borders around
 * the litems (its the ww background!).
 *
 * Revision 1.1  1999/09/19 22:31:36  jrh
 * Initial revision
 *: 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <qdos.h>
#include <qptr.h>
#include "qpop3.h"

long _stack = 12000;

void (*_SigStart)(void) = NULL;

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread) (struct UFB *,void *,unsigned int) = NULL;
int (*_conwrite) (struct UFB *,void *,unsigned int) = NULL;
char *_endmsg = NULL;

typedef struct mailinfo
{
    int nbytes;
    char *to;
    char *from;
    char *subject;
} MAILINFO;

typedef struct mres
{
    short menu;
    short item;
} MRES;

static MRES Mres;
            
typedef struct mitem
{
    short len;
    char chrs[1];
} MITEM;

typedef struct
{
    void *next;
    void *item;
} LLIST;

typedef struct
{
    struct QD_text *qtext;
    unsigned char status;
} MDEF;

#include "version.h"

char _prog_name[] = "qpop3 v" VERSION " " __DATE__ ;

typedef struct WM_menw WM_menw_t;

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row);
static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1

static WM_PWCB (1) pwcy0 = {0};
static WM_PWCB (1) pwcy1 = {0};

static QD_TEXTI (PROMPT,  "QPOP");
static QD_TEXTI (PROMPT1, "Pop Servers");
struct {short len; qchar_t chrs[256];} PROMPT2;

static long MESC (WM_wwork_t *wwk, struct WM_litm *li);
static long MBUT (WM_wwork_t *wwk, struct WM_litm *li);
static struct WM_action mesc = {JSR, wm_actli, MESC};
static struct WM_action butt = {JSR, wm_actli, MBUT};

static long MMOVE (WM_wwork_t *wwk, struct WM_litm *li);

static struct WM_action mmove = {JSR, wm_actli, MMOVE};

static QD_TEXTI (ESCAPE, "Quit");
static QD_TEXTI (VIEW, "View");
static QD_TEXTI (SAVE, "Save");
static QD_TEXTI (SAVEA, "Save All");
static QD_TEXTI (DELE, "Delete");
static QD_TEXTI (RESE, "Reset");
static QD_TEXTI (CLOS, "Close");

#define DEFX 480
#define DEFY 240

#define B_V 3
#define B_S 4
#define B_A 5
#define B_D 6
#define B_R 7
#define B_C 8

#define BUTTON_V     (1 << B_V)
#define BUTTON_S     (1 << B_S)
#define BUTTON_A     (1 << B_A)
#define BUTTON_D     (1 << B_D)
#define BUTTON_R     (1 << B_R)
#define BUTTON_C     (1 << B_C)

#define BUTTONS (BUTTON_V|BUTTON_S|BUTTON_A|BUTTON_D|BUTTON_R|BUTTON_C)
#define BUTTON_ACT (BUTTON_V|BUTTON_S|BUTTON_A|BUTTON_D)

#define TSZ(__t) (6*(sizeof(__t)-1))

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;	/* calculate event for selection key */
}

static struct WM_action msize = {JSR, wm_actli, lit_event};

static struct WM_info info0[] =	/* information objects */
{
    {TSZ(PROMPT.chrs), 10, /* xsize, ysize         size */
     6, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_info info1[] =	/* information objects */
{
    {TSZ(PROMPT1.chrs), 10,/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT1},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_info info2[] =	/* information objects */
{
    {0, 10,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT2},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_infw infw[] =
{
 /*  xs  ys  xo   yo   flag     bw bc papr  pobj */
    { 0, 14,  0,   0,    0,     0, 0, 127,  NULL},    /* banner */      
    {36, 10,  0,   2,    0,     1,255, 7,  info0},    /* title  */
//  ---------------------------------------------------------------
    {0,  0 ,  0,  14,    0,     0, 0,  0,  NULL},     /* backdrop */
    {24, 10,  0,   2,    0,     1,255, 7,  NULL},    /* quit   */
    {22, 10,  4,   2,    0,     1,255, 7,  NULL},    /* move   */
    {22, 10, 28,   2,    0,     1,255, 7,  NULL},    /* size   */
    {0,  12, 24,  20,    0,     0, 0, 7,    info1},  /* title 1*/ 
    {0,  12, 24,  20,    0,     0, 0, 7,    info2},  /* title 1*/ 
#define MSG_WID 7  // ^^^^^^^ The above
//  ---------------------------------------------------------------
    {TSZ(VIEW.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},
    {TSZ(SAVE.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},
    {TSZ(SAVEA.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},
    {TSZ(DELE.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},
    {TSZ(RESE.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},
    {TSZ(CLOS.chrs),
         10,  0, 0, 0,     1,255, 7,  NULL},    
    {-1}
};

static struct WM_menw mws[] =	/* menu window */
{
    {
        0, 0,		/* xsize, ysize         size */
        2, 36,		/* xorg, yorg           and origin */
        0,  		/* flag                 no clear + shadow */
        1, 0, 7,	/* borw, borc, papr     border width/clr, paper */
        NULL,		/* *pspr                pointer to sprite */
        &mdraw,		/* *draw                draw routine */
        wm__mhit,	/* *hit                 hit routine */
        wm__pnsc,	/* *ctrl                control routine */
        0, MAX_SECT,	/* nxsc, nysc           max x,y sections */
        0, 0, 0,	/* skey, 2 spare        selection keystroke */
        NULL,		/* *pwcb            part window ctrl block */
        0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
        2, 7, 0,        /* psac, psbc, pssc arrow/bar clrs */
        (WM_pwcb_t *) &pwcy0,	/* *pwcb            part window ctrl block */
        0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
        2, 7, 0,        /* psac, psbc, pssc arrow/bar clrs */
        NULL,		/* *mstt                menu status area */
        1, 2,		/* curw, curc           current item width/clr */
        7, 255, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
        7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
        2, 7, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
        1, 0,		/* ncol, nrow           columns and rows */
        0, 0,		/* xoff, yoff           window offset */
        {0, 0},		/* -xsize, -xspce     or *xspc spacing list */
        {-10, -12},	/* -ysize, -yspce     or *yspc spacing list */
        NULL, NULL,	/* *xind, *yind         not implemented */
        NULL		/* *rowl                row list */
    },
    {
        0, 0,		/* xsize, ysize         size */
        2, 36,		/* xorg, yorg           and origin */
        0,  		/* flag                 no clear + shadow */
        1, 0, 7,	/* borw, borc, papr     border width/clr, paper */
        NULL,		/* *pspr                pointer to sprite */
        &mdraw,		/* *draw                draw routine */
        wm__mhit,       /* *hit                 hit routine */
        wm__pnsc,	/* *ctrl                control routine */
        1, MAX_SECT,	/* nxsc, nysc           max x,y sections */
        0, 0, 0,	/* skey, 2 spare        selection keystroke */
        NULL,		/* *pwcb            part window ctrl block */
        0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
        2, 7, 0,	  /* psac, psbc, pssc arrow/bar clrs */
        (WM_pwcb_t *) &pwcy1,	/* *pwcb            part window ctrl block */
        0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
        2, 7, 0,          	/* psac, psbc, pssc arrow/bar clrs */
        NULL,		/* *mstt                menu status area */
        1, 2,		/* curw, curc           current item width/clr */
        7, 4, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
        7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
        2, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
        1, 0,			/* ncol, nrow           columns and rows */
        0, 0,			/* xoff, yoff           window offset */
        {0, 0},			/* -xsize, -xspce     or *xspc spacing list */
        {-10, -12},		/* -ysize, -yspce     or *yspc spacing list */
        NULL, NULL,		/* *xind, *yind         not implemented */
        NULL		/* *rowl                row list */
    }
};

static struct WM_litm plitm[] =	/* loose item */
{
 /*  xs  ys    xo  yo  xj  yj   type      key      pobj     item  pact */
    {24, 10,    0,  2,  0,  0, TYP_TEXT,   3,    &ESCAPE,    0,  &mesc},
    {22, 10,    4,  2,  0,  0,   2,     K_MOVE,  &mes_move,  1,  &mmove},
    {22, 10,   28,  2,  0,  0,   2,     K_SIZE,  &mes_size,  2,  &msize},
    {TSZ(VIEW.chrs),
         10,    0,0, 0,0, TYP_TEXT, 'V',    &VIEW,      3,  &butt},
    {TSZ(SAVE.chrs),
         10,    0, 0, 0,0, TYP_TEXT, 'S',    &SAVE,      4,  &butt},
    {TSZ(SAVEA.chrs),
         10,    0, 0, 0,0, TYP_TEXT, 'A',    &SAVEA,     5,  &butt},
    {TSZ(DELE.chrs),
         10,    0, 0, 0,0, TYP_TEXT, 'D',    &DELE,      6,  &butt},
    {TSZ(RESE.chrs),
         10,    0, 0, 0,0, TYP_TEXT, 'R',    &RESE,      7,  &butt},
    {TSZ(CLOS.chrs),
         10,    0, 0, 0,0, TYP_TEXT, 'C',    &CLOS,      8,  &butt},
    {-1}
};

struct WM_appl appl[] = {(WM_appw_t *)mws, (WM_appw_t *)(mws+1), 0};

#define ninfw   ((sizeof(infw)/sizeof(WM_infw_t))-1)
#define ninfo   3
#define nlitm   ((sizeof(plitm)/sizeof(WM_litm_t))-1)
#define nappl   2


static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    DEFX, DEFY, 0, 0, 6, 12,
    {
	{8, 0, 0, 0},		/* infw[0] Title bar, x scale */
	{0, 0, 4, 0},		/* infw[1] Title , centre */
	{0, 0, 0, 0},		/* info[0], no scale */
        {8, 8, 0, 0},           /* infw[2], scale */
	{0, 0, 8, 0},		/* infw[3], quit right */
	{0, 0, 0, 0},		/* infw[4], move no scale */
	{0, 0, 0, 0},		/* infw[5], size no scale */

	{0, 0, 0, 0},		/* infw[6], subt1 no scale */
	{0, 0, 0, 0},		/* info[1], no scale */

	{8, 0, 0, 0},		/* infw[7], subt2, noscale */
	{0, 0, 0, 0},		/* info[2], no scale */

	{0, 0, 0, 0},		/* infw[8], no scale */
        {0, 0, 0, 0},		/* infw[9], no scale */
	{0, 0, 0, 0},		/* infw[10], no scale */        
	{0, 0, 0, 0},		/* infw[11], no scale */
        {0, 0, 0, 0},		/* infw[12], no scale */
	{0, 0, 0, 0},		/* infw[13], no scale */        
 
	{0, 0, 8, 0},		/* litm[0], right jst */
	{0, 0, 0, 0},		/* litm[1], no scale */
	{0, 0, 0, 0},		/* litm[2], no scale */

	{0, 0, 0, 0},		/* litm[3], no scale */
	{0, 0, 0, 0},		/* litm[4], no scale */
	{0, 0, 0, 0},		/* litm[5], no scale */        
	{0, 0, 0, 0},		/* litm[6], no scale */
	{0, 0, 0, 0},		/* litm[7], no scale */
	{0, 0, 0, 0},		/* litm[8], no scale */        

        {0, 0, 0, 0},	        /* appl[0], full scale */
	{8, 8, 0, 0}	        /* appl[1], full scale */
    }
};

static WM_wwork_t ww =	/* window working definition */
{
    NULL,	/* *wstat;              pointer to status area */
    (WM_wscale_t *) &wsc,	/* *wscale this was pointer to WDEF */
    0,		/* chid                 channel ID */
    NULL,	/* *pprec               pointer to pointer record */
    0,		/* psave                pointer position saved */
    0, 0, 0, 0,	/* 4 zero */
    appl,	/* *splst               pointer to sprite list */
    0, 0,	/* xsize, ysize will need changing */
    4, 23,	/* xorg, yorg           and origin */
    2,       	/* flag                 no clear + shadow */
    1, 4, 255,    	/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *sprite              pointer to sprite */
    1, 0,		/* curw, curc           current item width/clr */
    7, 255, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, plitm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};
    
static struct WM_wstat ws =	/* window status area */
{
    NULL,		/* *wwork               point back to work def */
    NULL,		/* *wdef                this was wdef */
    0,			/* chid             chan ID enclosing pointer */
    0, 0, 0,		/* swnr, xpos, ypos  sub-window and ptr posn */
    0, 0,		/* kstk, kprs           key stroke and press */
    0,			/* evnt                 event vector */
    0, 0, 0, 0,		/* xsiz, ysiz, xorg, yorg  */
    0, 0,		/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,	/* wmode, 2 spare       window mode and spare */
    NULL,		/* *ciact               current item "action" */
    -1,			/* citem                current item */
    0, 0, 0,		/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,		/* cihxs,ys, cihxo,yo   current item hit area */
    {0}			/* litem[40]            loose item status */
};

static struct WM_wsiz wl;

#ifdef DEBUGGING
void Report (char *ctl,...)
{
    va_list va;
    static FILE *fp = 0;
    if(fp == 0)
    {
        fp = fopen("win2_tmp_ql.debug","a");
    }
    va_start (va, ctl);
    vfprintf(fp, ctl, va);
    fflush(fp);
    va_end (va);
}
#endif

static void scale (struct WM_swdef *sw, char sc[], short dx, short dy)
{

    if (sc[0])
	sw->xsize += (dx * sc[0]) >> 3;
    if (sc[1])
	sw->ysize += (dy * sc[1]) >> 3;
    if (sc[2])
	sw->xorg += (dx * sc[2]) >> 3;
    if (sc[3])
	sw->yorg += (dy * sc[3]) >> 3;
}

static void GetLimits (struct WM_wwork *wwk)
{
    short nln;
    struct WM_wsiz wl;

    iop_flim (wwk->chid, -1, &wl);
    wwk->wscale->xmax = ((wl.xsize - 18) / 6) * 6;
    wwk->wscale->ymax = 16 + 12*((wl.ysize - 24)/12);
}

short re_scale (struct WM_wwork *wwk, short *pdx, short *pdy)
{
    short newsx;
    short newsy;
    int iscale;
    short res = 0;
    struct WM_wscale *sc;
    struct WM_infw *infw;
    struct WM_info *info;
    struct WM_litm *litm;
    struct WM_appl *appl;
    struct WM_appw *appw;

    sc = wwk->wscale;

    newsx = wwk->xsize + ((*pdx + sc->xinc / 2) / sc->xinc) * sc->xinc;

    if (newsx > sc->xmax)
	newsx = sc->xmax;
    else if (newsx < sc->xmin)
	newsx = sc->xmin;

    *pdx = newsx - wwk->xsize; 

    newsy = wwk->ysize + ((*pdy + sc->yinc / 2) / sc->yinc) * sc->yinc;

    if (newsy > sc->ymax)
	newsy = sc->ymax; 
    else if (newsy < sc->ymin)
	newsy = sc->ymin;
    *pdy = newsy - wwk->ysize;

    if (*pdx || *pdy)
    {
	res = 1;
        wwk->xsize = newsx;		/* set size */
        wwk->ysize = newsy;		/* set size */

	iscale = 0;
	if (infw = wwk->pinfo)
	    while (infw->xsize >= 0)
	    {
		scale ((WM_swdef_t *) infw, sc->s8[iscale++], *pdx, *pdy);

		if (info = (infw++)->pobl)
		    while (info->xsize >= 0)
		    {
			scale ((WM_swdef_t *) info, sc->s8[iscale++], *pdx, 
			       *pdy);
                        info++;
		    }
	    }

	if (litm = wwk->plitm)
	    while (litm->xsize >= 0)
	    {
		scale ((WM_swdef_t *) litm, sc->s8[iscale++], *pdx, *pdy);
                litm++;
	    }
	if (appl = wwk->pappl)
	    while (appw = (appl++)->pappw)
		scale ((WM_swdef_t *) appw, sc->s8[iscale++], *pdx, *pdy);
    }
    return res;
}

static long lit_reset (WM_wwork_t *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */
}


long resize (struct WM_wwork *wwk, short lit_size)
{
    static short flag = 0, ix, iy;
    short dx, dy, last;
    int sts;
    short res = 0;

    lit_reset (wwk, 2);

    GetLimits (wwk);

    sts = wm_chwin (wwk, &dx, &dy);
    dx = -dx;
    dy = -dy;		/* our true sense of change size */

    res = re_scale (wwk, &dx, &dy);
    if(res)
    {
	wm_unset (wwk);	
	wwk->xorg = wwk->wstat->ptpsx - wwk->xorg;
	wwk->yorg = wwk->wstat->ptpsy - wwk->yorg;
	sts = wm_prpos (wwk, 
			(short) (wwk->wstat->ptpsx - dx), 
			(short) (wwk->wstat->ptpsy - dy));
	wm_wdraw (&ww);
    }
    else
	wm_ldraw(wwk, -1);

    return (long)res;
}

void menu_chks (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;
    short spacing;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */
    spacing = -menu->ys.c._spce;

    if (menu->nrow && menu->nrow > menu->ysize / spacing)
    {
	if (pwcb->nsec == 0)
	    menu->xsize -= WW_XBAR;	/* adjust width for bar */
	pwcb->nsec = 1;		/* one section */
	pwcb->s[0].stt = 0;	/* from zero */
	pwcb->s[0].siz = ((menu->ysize ) / spacing); /* size */
    }
    else
    {
	if (pwcb->nsec)
	    menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
    }
    menu->xs.c._spce = -(menu->xsize) / menu->ncol;
    menu->xs.c._size = menu->xs.c._spce + menu->curw * 4;

}

/*******************************************************************************
*
*   Given a pointer to a menu sub-window working definition for a scrollable
*   menu this function removes the scroll bar and arrows (if present)
*
*******************************************************************************/

void menu_rems (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */

    if (pwcb->nsec)
    {
	menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;
    }				/* no arrows, no offset */
}

/* Given a linked list and a menu, loads the menu */

void LoadMenu (struct WM_menw *menu, LLIST *list)
{
    int i;
    struct WM_rowl *rowl;
    struct WM_mobj *mobj;
    char *mstt;
    LLIST *p;
    int nitem = 0;

    for (p = list; p; p = p->next, nitem++)
    	; /* NULL LOOP to find nitems */

    if (menu->rowl)
    {
	free (menu->rowl);
    }

    menu->rowl = NULL;
    menu->ncol = 1;
    menu->nrow = nitem;
    
    if(list)
    {
        menu->rowl =
            rowl = (struct WM_rowl *)
            malloc((int)
                   (
                       (sizeof (struct WM_rowl) +
                        sizeof (struct WM_mobj) + 1
                        ) * nitem));
        
        mobj = (struct WM_mobj *)
            (((char *) rowl) + sizeof (struct WM_rowl) * nitem);

        menu->mstt =
            mstt = ((char *) mobj) + sizeof (struct WM_mobj) * nitem;

        for (i = 0; i < nitem; i++)	/* initialise menu structures */
        {
            mobj->xjst = 1;
            mobj->yjst = 0;
            mobj->type = 0;
            mobj->skey = 0;
            mobj->pobj = (char *) ((MDEF *) list->item)->qtext;
            mobj->item = i;
            mobj->pact = &mact;
            rowl->rows = mobj++;	/* one object per row */
            (rowl++)->rowe = mobj;
            *(mstt++) = ((MDEF *) list->item)->status;
            list = list->next;	/* next text */
        }
    }
}



static long MMOVE (struct WM_wwork *wwk,  struct WM_litm *li)
{
    short dx, dy;
    lit_reset (wwk, 1);
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    return 0;	/* and return */
}

#define LMARGIN 60

int menu (LLIST *MList, short icount, short flag, short nx)
{
    int rval;
    short flg = 0;
    int mx, xsize = 0, ysize = 0;
    short yinc;
    int i;
    
    yinc = 12;
    ysize =  16+icount * yinc;

    if(ysize > DEFY)
    {
        ysize = 16 + yinc*((DEFY - 60)/yinc) ;
    }

    if(nx > 20) nx = 20;
    xsize = nx*6+16;

    mx = wl.xsize - 18;

    infw[0].xsize = mx;
    ww.xsize = mx;
    ww.ysize = DEFY-2;
    
    mws[0].xsize = xsize-4;
    infw[2].xsize = mx;
    infw[2].ysize = ww.ysize-14;
    
    infw[6].xorg = mws[0].xorg = 8;
    infw[6].xsize = info1[0].xsize+6;
    
    mws[0].ysize = ysize-16;
    mws[0].xs.c._size = -mws[0].xsize + 4;
    mws[0].xs.c._spce = -mws[0].xsize;
    mws[0].ys.c._spce = -yinc;

    mws[1].xorg = mws[0].xorg + mws[0].xsize + 16;
    infw[7].xorg = mws[1].xorg;
    
    mws[1].xsize = mx - mws[1].xorg - 24;
    infw[7].xsize = mws[1].xsize;
    
    mws[1].ysize = DEFY-68;
    mws[1].xs.c._size = -mws[1].xsize + 4;
    mws[1].xs.c._spce = -mws[1].xsize;
    mws[1].ys.c._spce = -yinc;
 
    infw[3].xorg = plitm[0].xorg = mx - plitm[0].xsize - 6;
    infw[1].xorg = (mx - infw[1].xsize) / 2;

    mws[0].curc = 2;
    mws[0].borc = 255;        

    mws[1].curc = 2;
    mws[1].borc = 255;        

    infw[0].papr = 84;

    for(i =0; i < 6; i++)
    {
        short xo,yo;
        xo = i & 1;
        yo = i / 2;

        plitm[i+3].xorg = infw[i+8].xorg = 18+xo*62;
        plitm[i+3].yorg = infw[i+8].yorg = DEFY-80 + yo*12;        
        plitm[i+3].xsize = 60;
        infw[i+8].xsize = 60;
    }

    LoadMenu (mws, MList);
    LoadMenu (mws+1, 0);

    strcpy((char*)PROMPT2.chrs, "No connection");
    PROMPT2.len = strlen((char*)PROMPT2.chrs);
    info2[0].xsize = 6*(PROMPT2.len);

    wm_prpos (&ww, -1, -1);	/* pull down */
    wm_wdraw (&ww);
}

void MenuWait(LLIST *slist, LLIST *mlist)
{
    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if(ws.evnt & PT_WSIZE)
	{
	    menu_rems(mws);
	    menu_rems(mws+1);            
	    resize(&ww, 2);
            LoadMenu (mws, slist);
            LoadMenu (mws+1, mlist);            
	    MDRAW(&ww, mws);
	    MDRAW(&ww, mws+1);            
	}
    }
}

static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw)
{
    menu_chks (mw);
    if(((struct WM_pwcb *)mw->ypwcb)->nsec)
        wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

/*-------------------------------------------------------.
| Reset an item in a menu after the user has selected it |
`-------------------------------------------------------*/

static void resetobj (WM_wwork_t * wwk, WM_menw_t * mw, char *mst)
{
    *mst = WSI_MKAV;
    wm_mdraw (wwk, (WM_swdef_t *) mw, -1);
    *mst = WSI_AVBL;
}

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row)
{
    struct WM_mobj *mobj;
    int moff;
    
    moff = (mw - mws);
    mobj = mw->rowl[row].rows;	/* current menu object */
    Mres.menu = moff;
    Mres.item = mobj->item;
    return PT__CAN;
}

static long MESC (WM_wwork_t *wwk, struct WM_litm *li)
{
    Mres.menu = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}

static long MBUT (WM_wwork_t *wwk, struct WM_litm *li)
{
    Mres.menu = 2;
    Mres.item = li->item;

    return PT__CAN;		/* and return CAN event */
}

void DecodeLine(char *ln, char **host, char **user, char **pass)
{
    char *p,*q = ln;
    
    *host = *user = *pass = 0;

    if((p = memchr(q, 0, 256)))
    {
        *host = q;
        p++;
        q = p;
        if((p = memchr(q, 0, 256)))
        {
            *user = q;
            p++;
            q = p;
        }
        if((p = memchr(q, 0, 256)))
        {
            *pass = q;
        }
    }
}

char * buildline(char *txt, int *ll)
{
    char ln[256];
    char *r = NULL,*p0,*p1,*q;
    int flag = 0;
    int cnt = 0;
    
    *ll = 0;
    
    q = ln;
    
    for(p0 = txt; p1 = strtok(p0," \t"); p0 = NULL)
    {
        switch(flag)
        {
            case 0:
                if(strcmp(p1,"skip") == 0 || strcmp(p1,"poll") == 0)
                {
                    flag = 1;
                }
                else if(strcmp(p1,"user") == 0)
                {
                    flag = 2;
                }
                else if(strcmp(p1, "pass") == 0)
                {
                    flag = 3;
                }
                break;
            case 1:
            case 2:
            case 3:                
                cnt += flag;
                q = stpcpy(q, p1);
                *q++ = '\0';
                flag = 0;
                break;
        }
    }
    if(cnt == 6) /* small sanity check */
    {
        *ll = (int)(q - ln);
        r = memcpy(txt, ln, *ll);
    }
    
    return r;
}


LLIST * BuildMenu (int *ni, FILE *fp, short flag, short *nx)
{
    int n = -1;
    char *pt, txt[256];
    int nc;
    int ll;
    MITEM *s;
    MDEF *pm;
    LLIST *pl, *pz = 0, *ph = NULL;
    
    n = 0;
    while(fgets(txt, sizeof(txt), fp))
    {
	char *l;
	if((l = strchr(txt, '\n'))) *l = 0;
        if(*txt && *txt != '#')
        {
            if(strncmp(txt, "skip", 4) == 0 || strncmp(txt, "poll", 4) == 0)
            {
                if((pt = buildline(txt, &ll)) != NULL)
                {
                    nc = ll + 4;
                    s = (MITEM *) malloc (nc);
                    memcpy (s->chrs, pt, ll);
                    s->len = strlen (s->chrs);
                    if(s->len > *nx) *nx = s->len;
                    pm = (MDEF *) malloc (sizeof (MDEF));
                    pm->qtext = (struct QD_text *) s;
                    pm->status = (flag) ? WSI_AVBL: WSI_UNAV;
                    
                    pl = (LLIST *) malloc (sizeof (LLIST));
                    pl->item = pm;
                    pl->next = NULL;
                    if(ph == NULL) ph = pl;
                    if(pz)
                    {
                        pz->next = pl;
                    }
                    pz = pl;
                    if(s->len > *nx) *nx = s->len;
                    n++;
                }
                else
                {
                    fprintf(stderr, "Error %s\n", txt);
                    exit(-1);
                }
            }
        }
    }
    *ni = n;
    return ph;
}

void ResetAllHosts(short val, int seli)
{
    int i;
    
    for(i = 0; i < mws[0].nrow; i++)
    {
        if(i != seli)
            *(mws[0].mstt+i) = val; 
    }
    wm_mdraw (&ww, (WM_swdef_t *) mws, 0);    
    for(i = 0; i < mws[0].nrow; i++)
    {
        *(mws[0].mstt+i) = val & ~1;
    }
}
void ShowStatus(char *msg)
{
    strcpy((char*)PROMPT2.chrs, msg);
    PROMPT2.len = strlen((char*)PROMPT2.chrs);
    info2[0].xsize = 6*(1+PROMPT2.len);
    wm_idraw(&ww, ~(1 << MSG_WID));
}

int pop_resp(FILE *sfp, char *buf, int blen)
{
    while(fgets(buf, blen,sfp))
    {
        if(strncmp(buf,"+OK", 3) == 0 || strncmp(buf, "-ERR", 4) == 0)
        {
            break;
        }
    }
    return (*buf == '+');
}

void Say2pop (FILE* fp, char *ctl,...)
{
    va_list va;
    char buf[256];
    int n;
    
    va_start (va, ctl);
    vsprintf(buf, ctl, va);
    strcat(buf, "\r\n");
    n = write(fileno(fp), buf, strlen(buf));
    va_end (va);
}

#define LBUF 4096

FreeLL(LLIST *ll)
{
    LLIST *p, *q;
    for (p = ll;  p; )
    {
        q = p;
        p = p->next;
        free(q->item);
        free(q);
    }
}

LLIST *ReadToDot(FILE *fp, int *pnl)
{
    char *lbuf = malloc(LBUF);
    LLIST *pl, *pz = 0, *ph = NULL;
    *pnl = 0;
    
    while(fgets(lbuf, LBUF, fp))
    {
        if(*lbuf == '.' && (*(lbuf+1) == '\r' || *(lbuf+1) == '\n'))
        {
            break;
        }
        else
        {
            char *p,*q;
            int n;
            
            if((p = strchr(lbuf,'\r')) == NULL)
            {
                if((p = strchr(lbuf,'\n')) == NULL)
                {
                    p = lbuf+LBUF;
                }
            }
            n = (int)(p - lbuf);
            q = malloc(n+1);
            memcpy(q, lbuf, n);
            *(q+n) = 0;
            pl = (LLIST *) malloc (sizeof (LLIST));
            pl->item = q;
            pl->next = NULL;
            if(ph == NULL) ph = pl;
            if(pz)
            {
                pz->next = pl;
            }
            pz = pl;
            *pnl = *pnl +1;
        }
    }
    free(lbuf);
    return ph;
}


LLIST *ListPop(FILE *sfp)
{
    LLIST *ll = NULL;
    char msg[256];
    LLIST *ml,*mh=0,*mz=0;
    MAILINFO mi;
        
    Say2pop(sfp, "LIST");
    if(pop_resp(sfp, msg, sizeof(msg)))
    {
        int nl;
        int nm = 0;
        LLIST *p,*mm;
 
        ll = ReadToDot(sfp, &nl);
        
        sprintf(msg,"You have %d message(s)", nl);
        ShowStatus(msg);
        
        for (p = ll;  p; p = p->next)
        {
            int in, nb;
            LLIST *pl,*q;
            nm++;
            
            sscanf(p->item, "%d %d", &in, &nb);
            Say2pop(sfp, "TOP %d 0", in);
            pop_resp(sfp, msg, sizeof(msg));
            pl = ReadToDot(sfp, &nl);
            for(q = pl; q; q = q->next)
            {
                char *ml = q->item;
                
                if(strncmp(ml, "To: ", 4) == 0)
                {
                    mi.to = ml+4;
                }
                if(strncmp(ml, "From: ", 6) == 0)
                {
                    mi.from = ml+6;
                }
                if(strncmp(ml, "Subject: ", 9) == 0)
                {
                    mi.subject = ml+9;                    
                }
            }
            mi.nbytes = nb;
            {
                 MITEM *s;
                 MDEF *pm;
                 char mtxt[128];
                 int ll;
                 
                 sprintf(mtxt, "%-3d %-20.20s %-30.30s %5d %s",
                         nm, mi.to, mi.from, mi.nbytes, mi.subject);
                 ll = strlen(mtxt);
                 s = (MITEM *) malloc (ll+4);
                 memcpy (s->chrs, mtxt, ll);
                 s->len = ll;
                 pm = (MDEF *) malloc (sizeof (MDEF));
                 pm->qtext = (struct QD_text *) s;
                 pm->status = WSI_AVBL;
                 ml = (LLIST *) malloc (sizeof (LLIST));
                 ml->item = pm;
                 ml->next = NULL;
                 if(mh == NULL) mh = ml;
                 if(mz)
                 {
                     mz->next = ml;
                 }
                 mz = ml;
            }
            FreeLL(pl);
        }
        FreeLL(ll);
    }
    else
    {
        ShowStatus(msg);
    }
    
    if(mh)
    {
        LoadMenu(mws+1, mh);
        MDRAW(&ww, mws+1);            
    }
    return ml;
}

LLIST * ConnectHost(char *host, char *user, char *pass, int mitem, FILE **pfp)
{
    int sock, n, fd, retval;
    struct sockaddr_in name;
    struct hostent *h;
    struct servent *servent;
    char msg[256];
    int err = 0;
    FILE *sfp;
    LLIST *ml = 0;
    
    ResetAllHosts(WSI_MKUN, mitem);    
    if ((sock = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    {
        sprintf(msg,"socket failure %d", (err = errno));
    }
    else
    {
        if ((h = gethostbyname (host)) == NULL)
        {
            sprintf(msg,"host lookup fails");
            err = -1;
        }
        else
        {
            if((servent = getservbyname("pop-3", "tcp")) == NULL)
            {
                sprintf(msg,"service lookup fails");
                err = -1;
            }
            else
            {
                name.sin_family = h->h_addrtype;
                name.sin_port = servent->s_port;
                name.sin_addr = *((struct in_addr *) h->h_addr);
                retval = connect (sock, (struct sockaddr *) &name,
                                  sizeof (name));
                if (retval)
                {
                    sprintf(msg, "connect fails %d", (err=errno));
                }
                else
                {
                    sprintf(msg,"Connected to %s", host);
                }
            }
        }
    }
    ShowStatus(msg);

    if(err == 0)
    {
        sfp = fdopen(sock,"r+");
        setvbuf(sfp,  NULL, _IONBF, 0);
   
        if(pop_resp(sfp, msg,sizeof(msg)))
        {
            Say2pop(sfp, "USER %s", user);
            if(pop_resp(sfp, msg, sizeof(msg)))
            {
                Say2pop(sfp, "PASS %s", pass);
                if(pop_resp(sfp, msg, sizeof(msg)))
                {
                    ml = ListPop(sfp);
                    *pfp = sfp;
                }
                else
                {
                    ShowStatus("Login failed");
                }
            }
            else
            {
                ShowStatus("Login failed");                
            }
        }
        else
        {
            ShowStatus("POP server error");
        }
    }

    return ml;
  
}

void SetButtons(short val, int flag)
{
    int i;
    
    for(i = 0; i < 32; i++)
    {
        if(flag & (1 << i))
        {
            ws.litem[i] = val;
        }
    }
    wm_ldraw (&ww, -1);    
    for(i = 0; i < 32; i++)
    {
        if(flag & (1 << i))
        {
            ws.litem[i] = (val & ~1);
        }
    }
}

void SaveMsg(FILE*fp, int nm)
{
    char fn[PATH_MAX];
    LLIST *tl,*p;
    char msg[256];
    FILE *pp;
    int nl;
    
    Say2pop(fp, "TOP %d 99999", nm);
    pop_resp(fp, msg, sizeof(msg));
    tl = ReadToDot(fp, &nl);
    if(tl)
    {
        char *sdir;
        char *sp;
        
        if((sdir = getenv("POP_SAVEDIR")) == NULL)
        {
            sdir = "ram2_";
        }
        sp = stpcpy(fn, sdir);

        if(*(sp-1) != '_')
        {
            *sp++ = '_';
        }

        sprintf(sp, "msg_%d", nm);
        sp = fn + strlen(fn);
        while(access(fn, F_OK) == 0)
        {
            *sp++ = '_';
            *sp = 0;
        }
        
        pp = fopen(fn, "w");
        if(pp)
        {
            char cmd[128];
            for (p = tl; p ; p = p->next)
            {
                fprintf(pp, "%s\n", p->item);
            }
            fclose(pp);
        }
        FreeLL(tl);
    }
}

void DeleMsg(FILE*fp, int nm)
{
    char msg[256];
    Say2pop(fp, "DELE %d", nm);
    pop_resp(fp, msg, sizeof(msg));
}

void ViewMsg(FILE*fp, int nm)
{
    char fn[PATH_MAX];
    LLIST *tl,*p;
    char msg[256];
    FILE *pp;
    static int serial = 0;
    
    Say2pop(fp, "TOP %d 99999", nm);
    if(pop_resp(fp, msg, sizeof(msg)))
    {
        tl = ReadToDot(fp, &nm);
        if(tl)
        {
            sprintf(fn, "ram1_%x.%x", getpid(), serial++);
            pp = fopen(fn, "w");
            if(pp)
            {
                char cmd[128];
                
                for (p = tl; p ; p = p->next)
                {
                    fprintf(pp, "%s\n", p->item);
                }
                fclose(pp);
                fork(-1, "win3_exe_qless", fn);
            }
            unlink(fn);
            FreeLL(tl);
        }
    }
}

void DoMsgList(FILE *fp, short sts, void (*func)())
{
    int nm,n,i;
    struct WM_mobj *mobj;
    struct WM_rowl *rowl;
    struct QD_text *s;

    rowl = (mws+1)->rowl;    
    for(i = n = 0; i < (mws+1)->nrow; i++)
    {
        if(sts == 0 || (*((mws+1)->mstt+i) & sts))
        {
            mobj = rowl->rows;
            s= (struct QD_text *)mobj->pobj;
            nm = strtol ((char *)s->chrs, 0, 0);
            (func)(fp, nm);
        }
        rowl++;
    }
}
void AuRevoir(FILE *fp)
{
    if(fp)
    {
        char buf[128];
        Say2pop(fp, "QUIT");
        pop_resp(fp, buf, sizeof(buf));
        fclose(fp);
    }
}

int main(int ac, char **av)
{
    int opt;
    LLIST *RFxList = NULL, *ml = NULL;
    int RFxNum;
    int n;
    FILE *fp;
    
    short nx, nc;
    char flag = 1;    
    short nm;

    {
        char *poprc;
        poprc = getenv("QPOP3RC");
        if(!poprc)
        {
            perror("Config file");
            exit(-1);
        }
        fp = fopen(poprc, "r");
    }
    
    ww.chid = getchid(1);

    if(ww.chid < 0)
    {
        return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    iop_flim(ww.chid, -1, &wl);

    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
  
    
    if(fp)
    {
	nx = 0;	
	RFxList = BuildMenu(&RFxNum, fp, flag, &nx);
	fclose(fp);
	if(RFxList)
	{
            FILE *sfp = NULL;
	    menu(RFxList, RFxNum, flag, nx);
            SetButtons(WSI_MKUN, BUTTONS);
            while(MenuWait(RFxList, ml), Mres.menu != -1)
            {
                switch(Mres.menu)
                {
                    case 0:
                    {
                        short i;
                        LLIST *p;
                        MITEM *s;
                        MDEF *pm;
                        char *host, *user, *passwd;
                        
                        for (p = RFxList, i = 0; i < Mres.item;
                             p = p->next,i++)
                            ; /* find item */
		
                        pm = (MDEF *) p->item;
                        s = (MITEM *) pm->qtext;
                        DecodeLine(s->chrs, &host, &user, &passwd);
                        if((ml  = ConnectHost(host, user, passwd,
                                              Mres.item, &sfp))
                           == NULL)
                        {
                            ResetAllHosts(WSI_MKAV, -1);
                            SetButtons(WSI_MKUN, BUTTONS);
                        }
                        else
                        {
                            SetButtons(WSI_MKAV, BUTTON_R|BUTTON_C|BUTTON_A);
                        }
                        break;
                    }
                    case 1:
                    {
                        int act,n,i;
                        for(i = n = 0; i < (mws+1)->nrow; i++)
                        {
                            if(*((mws+1)->mstt+i) & WSI_SLCT)
                            {
                                n++;
                            }
                        }
                        act = (n) ? WSI_MKAV : WSI_MKUN;
                        SetButtons(act, BUTTON_ACT);
                        break;
                    }
                    
                    case 2:
                    {
                        char buf[128];
                        
                        switch(Mres.item)
                        {
                            case B_V:
                                DoMsgList (sfp, WSI_SLCT, ViewMsg);
                                SetButtons(WSI_MKAV, BUTTON_V);
                                break;
                            case B_S:
                                DoMsgList (sfp, WSI_SLCT, SaveMsg);
                                SetButtons(WSI_MKAV, BUTTON_S);
                                break;
                            case B_A:
                                DoMsgList (sfp, 0, SaveMsg);
                                SetButtons(WSI_MKAV, BUTTON_A);
                                break;
                            case B_D:
                                DoMsgList (sfp, WSI_SLCT, DeleMsg);
                                wm_swapp (&ww, 1, -1);
                                sd_clear (ww.chid, -1);
                                FreeLL(ml);
                                ml = ListPop(sfp);
                                SetButtons(WSI_MKAV, BUTTON_D);
                                break;
                            case B_R:
                                Say2pop(sfp, "RSET");
                                pop_resp(sfp, buf, sizeof(buf));
                                wm_swapp (&ww, 1, -1);
                                sd_clear (ww.chid, -1);
                                FreeLL(ml);
                                ml = ListPop(sfp);
                                SetButtons(WSI_MKAV, BUTTON_R);
                                break;
                            case B_C:
                                AuRevoir(sfp);
                                FreeLL(ml);
                                ml = NULL;
                                menu_rems(mws+1);
                                wm_swapp (&ww, 1, -1);
                                sd_clear (ww.chid, -1);
                                LoadMenu(mws+1, ml);
                                MDRAW(&ww, mws+1);            
                                ResetAllHosts(WSI_MKAV, -1);
                                SetButtons(WSI_MKUN, BUTTONS);
                                ShowStatus("No connection");
                                break;
                        }
                    }
                    break;
                }
	    }
                // If a connection exists, close it cleanly
            if(sfp)
            {
                AuRevoir(sfp);
            }
 	}
    }
    return 0;
}
